/*
 * Main.h
 *
 *  Created on: Mar 22, 2017
 *      Author: Patrick
 */

#ifndef MAIN_H_
#define MAIN_H_

#include "soc_C6748.h"
#include "hw_syscfg0_C6748.h"
#include "lcdkC6748.h"
#include "hw_types.h"
#include "interrupt.h"
#include "hw_uart.h"
#include "uart.h"
#include "timer.h"
#include "mcasp.h"
#include "psc.h"
#include "gpio.h"
#include "edma.h"
#include "edma_event.h"
#include <string.h>
#include <stdint.h>
#include "math.h"
#include "float.h"


#include "codecConfig.h"
#include "IHS_Utilities.h"
#include "RingBufferFunc.h"
#include "PROTOCOL.h"
#include "FilterFunctions.h"

#if (!defined IHS_LCDK) && (!defined IHS_SMV2)
	#error "define what system is used"
#endif
/******************************************************************************
**                      INTERNAL FUNCTION PROTOTYPES
******************************************************************************/
//void 		UARTTxFromRingBuff(struct RingBufferCharType *inStruct, unsigned char *inArray, unsigned int size);
//static int 	ReadUARTData(void);
//void 		uartPutData(unsigned int ulBase, unsigned char *inArray, unsigned int size);
//extern void UARTReadSize(char *inBuff_p, int size);
//void 		sendDataVIARingBuffer(unsigned short funcType, unsigned char *inArray, unsigned int size);

/******************************************************************************
**                      INTERNAL MACRO DEFINITIONS
******************************************************************************/
//Clock
#define SYS_CLK                 (456000000UL)
#define PLL0DIV2				(2UL)

//Application
#define AUDIO_SAMPLES_MAX				(1200)
//uncomment to pass the input audio straight out to the output
//#define DEBUG_AUDIOPASSTHROUGH
//uncomment to output waveform data through UART-USB port
// used in conjunction with math processing software
//#define DEBUG_WAVEFORMOUTPUT

//Audio
//The maximum size of the audio sample buffer [bytes]
#define AUDIO_BUFF_SIZE_MAX				(AUDIO_SAMPLES_MAX * BYTES_PER_SAMPLE)
//Slot size to send/receive data
#define SLOT_SIZE                   	(32u)
//Word size to send/receive data. Word size <= Slot size
#define WORD_SIZE                   	(32u)
//Sampling Rate which will be used by both transmit and receive sections
//Number of channels, L & R
#define NUM_I2S_CHANNELS              	(2u)
//Number of samples to be used per audio buffer
#define NUM_SAMPLES_PER_AUDIO_BUF    	(320u)
//Number of buffers used per tx/rx
#define NUM_BUF                     	(2u)
//Number of linked parameter set used per tx/rx
#define NUM_PAR                      	(2u)
//Specify where the parameter set starting is
#define PAR_ID_START                  	(40u)
//Number of samples in loop buffer
#define NUM_SAMPLES_LOOP_BUF        	(10u)
//Interrupt channels to map in AINTC
#define INT_CHANNEL_I2C             	(2u)
#define INT_CHANNEL_MCASP        		(2u)
#define INT_CHANNEL_EDMACC        		(2u)
//McASP Serializer for Receive
#define MCASP_XSER_RX               	(14u)
//McASP Serializer for Transmit
#define MCASP_XSER_TX                  	(13u)
//Below Macros are calculated based on the above inputs
#define NUM_TX_SERIALIZERS            	((NUM_I2S_CHANNELS >> 1) + (NUM_I2S_CHANNELS & 0x01))
#define NUM_RX_SERIALIZERS            	((NUM_I2S_CHANNELS >> 1) + (NUM_I2S_CHANNELS & 0x01))
#define I2S_SLOTS                      	((1 << NUM_I2S_CHANNELS) - 1)
#define BYTES_PER_SAMPLE               	((WORD_SIZE >> 3) * NUM_I2S_CHANNELS)
#define BYTES_PER_CHANNEL                (WORD_SIZE >> 3)
#define TX_DMA_INT_ENABLE             	(EDMA3CC_OPT_TCC_SET(1) | (1 << EDMA3CC_OPT_TCINTEN_SHIFT))
#define RX_DMA_INT_ENABLE              	(EDMA3CC_OPT_TCC_SET(0) | (1 << EDMA3CC_OPT_TCINTEN_SHIFT))
#define PAR_RX_START                   	(PAR_ID_START)
#define PAR_TX_START                  	(PAR_RX_START + NUM_PAR)
//Definitions which are not configurable
#define SIZE_PARAMSET                	(32u)
#define OPT_FIFO_WIDTH               	(0x02 << 8u)


#endif /* MAIN_H_ */
